<?php 

require_once dirname(__FILE__) . '/sesiones_lib.php' ;

class auth_lib
{
	private $tipo_conex_bd ;
	private $arr_params ;
	private $funcion ;
	private $otro ;
	
	private $login ;
	private $esta_logueado ;
	
	private $campo_login = 'username' ;
	private $campo_password = 'password' ;
	
	private $campo_bd_login = 'login' ;
	private $campo_bd_password = 'password' ;
	private $tabla_bd = 'usuarios' ;
	
	function __construct($tipo_conex_bd, $arr_params, $funcion ,$otro)
	{
		$this->tipo_conex_bd = $tipo_conex_bd ;
		$this->arr_params = $arr_params ;
		$this->funcion = $funcion ;
		$this->otro = $otro ;
		
		$this->sesion_lib = new sesiones_lib() ;
	}
	
	/**
	 * valida si la autenticacion existe
	 * @return unknown_type
	 */
	function checkAuth()
	{
		return $this->sesion_lib->ver('aut_lib_esta_logueado') ;
	}
	
	/**
	 * sale de sesion de autenticacion
	 * @return unknown_type
	 */
	function logout()
	{
		$this->sesion_lib->cambiar('aut_lib_esta_logueado', FALSE) ;
		$this->esta_logueado = FALSE ;
	}
	
	/**
	 * inicia la autenticacion
	 * @return unknown_type
	 */
	function start()
	{
		// verifica si sesion existe
		$esta_logueado = $this->checkAuth() ;
		// si existe, verifica timeout
		if($esta_logueado){
			// si time is out, desactiva sesion
		}else{			
			$this->validarLoginPassword() ;
			// si no existe valida login y password
			// si login y password ok
		}
		// configura sesion log
	}
	
	function validarLoginPassword()
	{
		// print_r($_POST) ;
		if(isset($_POST[$this->campo_login]) and isset($_POST[$this->campo_password])){
			$login = $_POST[$this->campo_login] ;
			$password = $_POST[$this->campo_password] ;
			
			if ($this->validarLoginPasswordBD($login, $password)){
				$this->sesion_lib->cambiar('aut_lib_login', $login) ;
				$this->sesion_lib->cambiar('aut_lib_esta_logueado', TRUE) ;
				$this->esta_logueado = TRUE ;	
			}
		}
	}
	
	function validarLoginPasswordBD($login, $password)
	{
		$cm = new citasMedicas() ;
		$sql = "SELECT `$this->campo_bd_password` as password  
		FROM `$this->tabla_bd` WHERE `$this->campo_bd_login`='$login'" ;
		echo "consulta: $sql" ;
		$res = $cm->conex->query($sql) ;
		
		if($res->num_rows < 1){
			return FALSE ;
		} 
		
		if ($res->fetch_object()->password != md5($password)) {
			return FALSE ;
		}
		
		return TRUE ;
	}
	/**
	 * devuelve el login actual en sesion
	 * @return unknown_type
	 */
	function getUserName()
	{
		return $this->sesion_lib->ver('aut_lib_login') ;	
	}
}