<?php


class Cita extends CitasMedicas 
{
	function __construct()
	{
		parent::__construct() ;
	}
	
	function registrar($codmed,$codpac,$fecha,$hora)
	{
		$consulta = "INSERT citas (cod_med,cod_pac,fecha,hora_in) 
		VALUES ('$codmed','$codpac','$fecha','$hora')";
		
		$res = $this->conex->query($consulta);
		
		if (! $res ){
			die("consulta=$consulta<br>".$this->conex->error);
		}
		
		if($this->conex->errno == 1026){
			$this->msg = "La cita ya existe.";
			$this->error = 1;
			return false;
		}
		
		$this->msg = "La cita fue creada.";
	}
		
	function Buscar($cod_med,$fecha_cita)
	{
		$consulta = "SELECT cod_pac,hora_in,hora_fin,estado FROM citas 
		WHERE cod_med = $cod_med and fecha = '$fecha_cita'"; //,cod_paciente, hora_in, hora_fin,estado 
		
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die("consulta='$consulta'".$this->conex->error);
		}
		
		$resul = array();
		
		while ($row = $res->fetch()) {
			$resul[]=$row;
		}
				
		return $resul;
	}
	
	/*
	funcion listar
	lista todas las citas existentes en la bd
	*/
	function listar()
	{
		$consulta = "SELECT c.codigo as cod_cita,c.fecha as fecha_cita,
		c.hora_in as hora_cita, c.cod_med as cod_med, c.cod_pac as cod_pac,
		c.estado as estado, m.nombre as nombre_med, 
		concat(p.nombres,' ',p.apellidos) as nombre_pac
		FROM citas c, medicos m, pacientes p WHERE c.cod_med = m.codigo
		and c.cod_pac = p.codigo"; //,cod_paciente, hora_in, hora_fin,estado 
		
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die("consulta='$consulta'. Error: " . $this->conex->error) ;
		}
		
		$resul = array();
		while ($row = $res->fetch_object()) {
			$resul[]=$row;
		}		
		return $resul;
	}
	
	/*
	funcion datos
	obtiene los datos de la cita medica:
	medico, paciente, fecha y hora
	*/
	function datos($cod_cita)
	{
		$consulta = "SELECT fecha, hora_in ,cod_med, cod_pac, estado
		 FROM citas  WHERE codigo = $cod_cita"; //,cod_paciente, hora_in, hora_fin,estado 
		$res = $this->conex->query($consulta);
		
		if (! $res){
			die("consulta='$consulta'".$this->conex->error) ;
		}
		//echo "sql: $consulta, error: " . $this->conex->error ."<br>" ;
		$fila = $res->fetch() ;
		
		return $fila;
	}
	
	function actualizar($cod_cita,$codmed,$codpac,$fecha,$hora)
	{
		$consulta = "UPDATE citas SET cod_med=$codmed,cod_pac=$codpac,fecha='$fecha',
		hora_in='$hora' WHERE codigo=$cod_cita";
		
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die("consulta=$consulta<br>".$this->conex->error);
		}
		
		$this->msg = "La cita fue actualizada.";
	}
	
	function cancelar($cod_cita)
	{
		$consulta = "UPDATE citas 
SET estado = 'cancelada'
WHERE 
	codigo=$cod_cita";
		//echo "en cita_lib::cancelar, linea 117. sql: $consulta" ;
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die("consulta=$consulta<br>".$this->conex->error);
		}
		
		$this->msg = "La cita fue Cancelada.";
	}
	
	function cambiarEstado($cod_cita, $estado)
	{
		$consulta = "UPDATE citas 
SET estado = '$estado'
WHERE 
	codigo=$cod_cita";
		//echo "en cita_lib::cancelar, linea 117. sql: $consulta" ;
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die("consulta=$consulta<br>".$this->conex->error);
		}
		
		$this->msg = "La cita fue $estado.";
	}
	
	function borrar($cod_cita)
	{
		$consulta = "DELETE FROM citas WHERE codigo=$cod_cita";
		
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die("consulta=$consulta<br>".$this->conex->error);
		}	
		
		$this->msg="La cita fue borrada.";
	}
	
	/*
	funcion solicitar
	envia un correo al asistente para solicitar la asignacion
	de la cita
	*/
	function solicitar($doc,$tipo_doc,$fecha,$hora)
	{
		$tipo_doc = CitasMedicas::nombreTipoDoc($tipo_doc);
		
		$para = $GLOBALS['CITAS_MEDICAS']['email_asist'] ;
		$asunto = "[Citas Medicas] Solicitar Cita";
		$msg = "Documento: $doc\nTipo Doc:$tipo_doc\nfecha: $fecha\nHora: $hora";
		//$cabecera = "From: from@origen.com";
		$cabecera = '' ;
		
		if (!@mail($para,$asunto,$msg,$cabecera)) {
			return $this->lanzarErr("Hubo un error al enviar el mensaje. Por favor informe al administrador del Sitio.");
			}
		return $this->msgOK("Mensaje enviado con éxito.");
	}
}