<?php

class HorarioMedico extends citasMedicas
{
	private $dias_semana = array('lunes','martes','miercoles','jueves','viernes','sabado','domingo');
	
	function horarioExiste($codigo)
	{
		$consulta="SELECT 1 FROM med_horario_med WHERE cod_med= '$codigo'";
		
		$data = $this->conex->getOne($consulta);
		
		if (! $data) {
			$this->msg = "El horario no existe.";
			return false;
		}
		return TRUE ;
	}
	
	function horPrinExiste($idmed)
	{
		$consulta="SELECT 1 FROM horarios_medicos WHERE cod_med= '$idmed'";
		
		$data = $this->conex->getOne($consulta);
		if (! $data) {
			$this->msg = "El horario no existe.";
			return false;
		}
		return true;

	}
	
	/*
	funcion crearPrincipal
	crea el horario principal, el cual es nico para cad mdico
	este horario solo se crea una vez
	$arr_horarios es un array asociativo, cada llave es el horario en si,
	el valor es la disponibilidad de los dias modificada
	*/
	function crearPrincipal($idmed,$arr_horarios)
		{
		$hora1 = new hora;
		
		$consulta = "INSERT horarios_medicos (cod_med,hora_in,dias_selec)";
		$llaves = array_keys($arr_horarios);
		$disp_dias = $arr_horarios[$llaves[0]];
		$hora_in = $hora1->segAhora($llaves[0]);
		$consulta .= " VALUES ('$idmed','$hora_in','$disp_dias')";
		
		for($i = 1; $i < sizeof($llaves); $i++){
			$disp_dias = $arr_horarios[$llaves[$i]];
			$hora_in = $hora1->segAhora($llaves[$i]);
			$consulta .= ",  ('$idmed','$hora_in','$disp_dias')";
		}
		
		$res = $this->conex->query($consulta);
		if (! $res ){
			die($this->conex->error) ;
			$this->error=1;
			return false;
		}
		
		$this->msg="El horario fu&eacute; creado.";
		
		return true;	
	}

	function modifPrincipal($idmed,$arr_horarios)
		{
		$hora1 = new hora;

		$llaves = array_keys($arr_horarios);
		
		$disp_dias = $arr_horarios[$llaves[0]];
		
		$hora_in = $hora1->segAhora($llaves[0]);
		
		$consulta = " UPDATE horarios_medicos SET  dias_selec='$disp_dias'
		WHERE cod_med = $idmed and hora_in = '$hora_in'";
		
		$res = $this->conex->query($consulta);
		
		if (! $res) {
			die($this->conex->error);
		}
		for($i = 1; $i < sizeof($llaves); $i++){
			$disp_dias = $arr_horarios[$llaves[$i]];
			$hora_in = $hora1->segAhora($llaves[$i]);
		
			$consulta = " UPDATE horarios_medicos SET  dias_selec='$disp_dias'
		WHERE cod_med = $idmed and hora_in = '$hora_in'";
			
			$res = $this->conex->query($consulta);
			
			if (! $res) {
				die($this->conex->error);
			}
		}
		
		$this->msg="El horario fue reemplazado.";
		
		return true;		
	}
	
	// obtener la lista de los horarios medicos para el dr. idmed
	// y devolverlos en un arreglo
	function listar($idmed)
	{
		$consulta = "SELECT * FROM horario_nodisp WHERE cod_med='$idmed'";
		
		$res = $this->conex->query($consulta);
		
		if (! $res) {
    		die($this->conex->error);
		}
		
		$resul = array();
		
		while ($row = $res->fetch()) {
    		
			$resul[]=$row;
		}

		return $resul;
	}
	
	/*
	funcion borrarHorNoDisp
	Borra el horario de no disponibilidad
	*/
	function borrarHorNoDisp($id_hor_nodisp)
	{
		$consulta = "DELETE FROM horario_nodisp WHERE codigo = '$id_hor_nodisp'";
		
		$res = $this->conex->query($consulta);
		
		if (! $res) {
    		die($this->conex->error);
		}
		
		$this->msg = "El horario m&eacute;dico fue borrado.";
		return true;
	}
	function listTipHor($tipo_sel)
	{
		$arr_tipo= array('disponible', 'no disponible');
		foreach ($arr_tipo as $tipo){
			if ($tipo_sel == $tipo) {
				$selec="selected";
				}
			else $selec="";
			
			$cad .= '<option value="'.$tipo.'" '.$selec.'>'.$tipo.'</option>'."\n";
			}
		return $cad;
	}
	
	function listCatHor($tipo_sel)
	{
		$arr_tipo= array('semanal', 'por dias');
		foreach ($arr_tipo as $tipo){
			if ($tipo_sel == $tipo) {
				$selec="selected";
				}
			else $selec="";
			
			$cad .= '<option value="'.$tipo.'" '.$selec.'>'.$tipo.'</option>'."\n";
			}
		return $cad;
	}
	
	/*
	funcion generaTabla
	Esta funcion se encarga de crear una tabla dinamicamente, con el listado de horarios,
	vs. los dias de la semana, y ademas debe mostrar en cada elemento de la tabla, 
	si esta disponible u ocupado.
	*/
	function generaTabla($idmed=NULL)
		{
		global $_HORA_IN,$_HORA_FIN,$CITAS_MEDICAS;
		$color_disp  = $CITAS_MEDICAS['COLOR_HOR_DISP'];
		$color_nodisp = $CITAS_MEDICAS['COLOR_HOR_NODISP'];
		$db = $this->conex;
		
		$hora1=new hora;
		
		$dias = array('lunes','martes','miercoles','jueves','viernes','sabado','domingo');
		
		$tabla = "<tr>
      <td scope=\"col\" class=\"borde_delgado\" >horario";
      	foreach($dias as $dia){
			if ($dia == 'sabado' or $dia == 'domingo'){
				$color_dia = $color_nodisp;
				}
			else $color_dia = $color_disp;
			$tabla .= "<td scope=\"col\" class=\"borde_delgado\" id=\"dia_$dia\" 
	  onClick=\"horario1.cambiaEstado('dia_$dia');\" 
	  bgcolor=\"$color_dia\">$dia\n";
	  		}
		if ($idmed != NULL) {
			$arr_estados = $this->obtenerEstado($idmed);
			}
		$hora2=$_HORA_IN;
		
		while($hora1->horAseg($hora2) <= $hora1->horAseg($_HORA_FIN) ){
			$hora_sig = $hora1->sumar($hora2,"1:00:00");
			$id_tdg = "hora_".$hora1->horAseg($hora2);
			$tabla .="<tr>\n
			<input type=\"hidden\" name=\"param_$id_tdg\" value=\"\" id=\"param_$id_tdg\">\n
			<td class=\"borde_delgado\" id=\"$id_tdg\"
			onClick=\"horario1.cambiaEstado('$id_tdg');\" bgcolor=\"$color_disp\" >".
			hora::verHora($hora2,'0seg')." - ".hora::verHora($hora_sig,'0seg')."</td>\n";
			foreach($dias as $dia){
				// ESTADO POR DEFECTO
				if ($idmed != NULL and $arr_estados) {
					$estado = $arr_estados[$hora2][$dia];
					$color = $estado?$color_disp:$color_nodisp;
					}
				else {
					if ($dia == 'sabado' or $dia == 'domingo'){
						$color=$color_nodisp;
						}
					else { 
						$color =$color_disp;
						}
					}
				$cad_color="bgcolor=\"$color\"";
				$id_td = $dia."_".$hora1->horAseg($hora2);
				$tabla .= "<td class=\"borde_delgado\" onClick=\"horario1.cambiaEstado('$id_td');\"
				 $cad_color id=\"$id_td\">&nbsp;</td>\n";
				}			
			$hora2 = $hora_sig;
			}
		return $tabla;
	}
	
	function obtenerEstado($idmed)
	{
		$consulta = "SELECT hora_in, dias_selec FROM horarios_medicos WHERE cod_med = '$idmed'";
		
		$res = $this->conex->query($consulta);
		
		if (!$res) {
    		die($this->conex->error);
		}
		
		$resul = array();
		if (! $res->num_rows){
			return false;
		}
		
		while ($row = $res->fetch()) {
			$arr_dias = $this->bitsAdias($row['dias_selec']);
			foreach ($arr_dias as $dia => $estado){		
				$resul[$row['hora_in']][$dia]=$estado;
				}
			}

		return $resul;
	}
	
	/*
	funcion bitsAdias
	convierte los dias codificados en binario a dias como nombres
	 y retorna un array asociativo de la forma
	*/
	function bitsAdias($dias_bin)
		{
		for ($i=0,$mul=1 ; $i < count($this->dias_semana);$i++,$mul*=2){
			//echo "dias&mul='".($dias_bin & $mul)."' >> mul = '".(($dias_bin & $mul) >> $i)."'<br> ";
			$arr_resul[$this->dias_semana[$i]]= ($dias_bin & $mul) >> $i;
			}
		return $arr_resul;
	}
	
	/*
	funcion crearHorNoDisp
	Crea un horario de no disponibilidad para un medico determinado
	*/
	function crearHorNoDisp($idmed,$fecha_in,$fecha_fin,$sel_h_in,$sel_h_fin,$idhornodisp=NULL)
	{
		if ($idhornodisp != '' ){
			$consulta ="UPDATE horario_nodisp SET fecha_in = '$fecha_in' ";
			if ($fecha_fin != NULL) 
				$consulta .= " ,fecha_fin = '$fecha_fin' ";
			else 
				$consulta .= " ,fecha_fin = NULL ";
			if ($sel_h_in  != NULL) 
				$consulta .= " ,hora_in = '$sel_h_in' ";
			else 
				$consulta .= " ,hora_in = NULL ";
			if ($sel_h_fin != NULL) 
				$consulta .= " ,hora_fin = '$sel_h_fin' ";			
			else
				$consulta .= " ,hora_fin = NULL ";			
			$consulta .= " WHERE cod_med=$idmed and codigo = $idhornodisp";
			}
		else {
		$consulta = "REPLACE horario_nodisp SET cod_med = $idmed, fecha_in = '$fecha_in'";
		if ($fecha_fin != NULL) $consulta .= " ,fecha_fin = '$fecha_fin' ";
		if ($sel_h_in != NULL) $consulta .= " ,hora_in = '$sel_h_in' ";
		if ($sel_h_fin != NULL) $consulta .= " ,hora_fin = '$sel_h_fin' ";
			}
		
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die($this->conex->error) ;
		} 
		
		if($this->conex->errno == 1026) {
			$this->msg = "El horario ya existe, por favor escoja otro.";
			$this->error = true;
			return false;
		}
		
		if ($this->conex->affected_Rows() == 2 or $idhornodisp != '') {
			$this->msg = "El horario de no disponibilidad fue reemplazado.";
			}
		else {
			$this->msg = "El horario de no disponibilidad fue creado.";
			}
	}
	
	/*
	funcion borrarTodosPrin
	Borra todos los horarios del codigo de medico correspondiente
	*/
	function borrarTodosPrin($cod_med)
	{
		$consulta="DELETE FROM horarios_medicos WHERE cod_med='$cod_med'";
	
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die($this->conex->error);
		}
		//horarios borrados
		
		return $this->conex->affected_Rows();
	}
	
	function borrarTodosNoDisp($cod_med)
	{
		$consulta="DELETE FROM horario_nodisp WHERE cod_med='$cod_med'";
		
		$res = $this->conex->query($consulta);
		
		if (!$res){
			die($this->conex->error);
		}
		//horarios borrados
		
		return $this->conex->affected_Rows();
	}	
}