<?php 
/**
 * clase pager_lib
 * 
 * permite paginar usando GET
 * 
 * esta version cambia la distancia entre enlace y enlace
 * ahora sera por ej 0,10,20,...
 * 
 * @author carlos
 *
 */

class pager2_lib
{
	/*
	* pagina actual
	*/
	var $pag_actual;
	/*numero de paginas = numero de registros / num de registros por pagina */
	var $NUM_PAGS = 1;
	/*num de registros por pagina*/
	var $regs_por_pag;
	
	var $total_registros;
	/**/
	var $campo_get_pag = 'pag_id';
	
	var $pags_visibles = 10;
	
	var $separa_pag = ' | ';
	
	function __construct()
	{	
		
	}
	
	function config($data)
	{
		foreach($data as $campo => $valor){
			if(property_exists($this, $campo)){
				$this->$campo = $valor ;
			}
		}
		
		if ($this->regs_por_pag != 0){
			$this->NUM_PAGS = ceil($this->total_registros / $this->regs_por_pag) ;
		}
		
		$this->revisaPagActual();
	}
	
	function revisaPagActual()
	{
		if (isset($_GET[$this->campo_get_pag]) )
		{
			$this->pag_actual = $_GET[$this->campo_get_pag] / $this->regs_por_pag + 1;
			//if ( $this->pag_actual > $this->NUM_PAGS )
			//	$this->pag_actual = $this->NUM_PAGS;
		}
		else
			$this->pag_actual = 1;
	}
	
	function verEnlaces()
	{
		if ( $this->total_registros <= $this->regs_por_pag ) 
			return;
	
		$enlace= '';
		
		$inicio_pags = $this->paginaActual() - round($this->pags_visibles / 2);
		if ( $inicio_pags < 1 )
			$inicio_pags = 1;
		//echo "inicio = $inicio_pags<br />";
		for ( $i = $inicio_pags ; ( $i < $this->pags_visibles + $inicio_pags ) and ( $i <= $this->NUM_PAGS ); $i++){
			if ( $i < ( $this->pags_visibles + $inicio_pags - 1)  and $i <= $this->NUM_PAGS - 1)
				$separa  = $this->separa_pag;
			else
				$separa = '';
			$enlace .= $this->verEnlacePagina($i) . $separa;
		}
		
		//enlace anterior
		if ( $inicio_pags > 1 )
			$enlace = $this->verEnlacePagina($inicio_pags - 1 , '<' ) . $this->separa_pag . $enlace;
		
		//enlace posterior
		if ( $inicio_pags + $this->pags_visibles < $this->NUM_PAGS )
		    $enlace =  $enlace . $this->separa_pag . $this->verEnlacePagina($inicio_pags + $this->pags_visibles , '>') ;
		
		//enlaces cada 10 o cada num_pags / pags_presentables ...pendiente
		
		return $this->verEnlacePagina(1,'Primero') .$this->separa_pag . $enlace . $this->separa_pag . $this->verEnlacePagina($this->NUM_PAGS, 'Ultimo');
	}

	
	function verEnlacePagina($pag, $nombre = NULL)
	{
		// multiplicador
		$indice = ($pag - 1) * $this->regs_por_pag ;
		
		if ( empty($nombre) )
			$nombre = $pag;
		$url_actual = $_SERVER['PHP_SELF'] ;
		
		// agrega los parametros existentes sin modificarlos
		// exceptuando el parametro de paginacion
		
		$params = '';
		if ( count($_GET ) )
		{
			foreach($_GET as $campo => $valor )
				if ( $campo != $this->campo_get_pag )
					$params .= "&$campo=$valor";
		}
		
		$url = $url_actual .'?' . $params . $this->verParamPagina($indice);
		$ret = "<a href=\"$url\">$nombre</a>";
		return $ret;
	}
	
	
	function verParamPagina($pag)
	{
		return "&{$this->campo_get_pag}=$pag";
	}
	
	function paginaActual()
	{
		return $this->pag_actual;
	}
	
	function indiceActual()
	{
		return ($this->pag_actual - 1) * $this->regs_por_pag ;
	}
	
	function numRegistros()
	{
		return $this->total_registros;
	}
		
	function limiteSQL()
	{
		$limite_inf = ( $this->pag_actual - 1 ) * $this->regs_por_pag ;
		return "LIMIT $limite_inf , {$this->regs_por_pag}";
	}
	
	
	

}
